Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -5056,31 +3444,30 @@
     int option;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &option, &omdObj))
-    {
-        return NULL;
-    }
-
-    if (omdObj != Py_None)
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &option, &omdObj)) {
+        return NULL;
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_update(call_id, option, &msg_data);	
+    }
+
+    status = pjsua_call_update(call_id, option, &msg_data);	
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_update(call_id, option, NULL);
-    }
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5088,46 +3475,43 @@
  * py_pjsua_call_send_request
  */
-static PyObject *py_pjsua_call_send_request
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_send_request(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int call_id;    
-    PyObject *method_obj;
+    PyObject *pMethod;
     pj_str_t method;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iOO", &call_id, &method_obj, &omdObj))
-    {
-        return NULL;
-    }
-
-    if (!PyString_Check(method_obj)) {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOO", &call_id, &pMethod, &omdObj)) {
+        return NULL;
+    }
+
+    if (!PyString_Check(pMethod)) {
 	return NULL;
     }
 
-    method.ptr = PyString_AsString(method_obj);
-    method.slen = PyString_Size(method_obj);
-
-    if (omdObj != Py_None)
-    {
+    method = PyString_ToPJ(pMethod);
+    pjsua_msg_data_init(&msg_data);
+
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_send_request(call_id, &method, &msg_data);	
+    }
+
+    status = pjsua_call_send_request(call_id, &method, &msg_data);	
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_send_request(call_id, &method, NULL);
-    }
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5135,42 +3519,42 @@
  * py_pjsua_call_xfer
  */
-static PyObject *py_pjsua_call_xfer
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_xfer(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int call_id;
     pj_str_t dest;
-    PyObject * sd;
+    PyObject *pDstUri;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iOO", &call_id, &sd, &omdObj))
-    {
-        return NULL;
-    }
-	
-    dest.ptr = PyString_AsString(sd);
-    dest.slen = strlen(PyString_AsString(sd));
-    
-    if (omdObj != Py_None)
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOO", &call_id, &pDstUri, &omdObj)) {
+        return NULL;
+    }
+
+    if (!PyString_Check(pDstUri))
+	return NULL;
+
+    dest = PyString_ToPJ(pDstUri);
+    pjsua_msg_data_init(&msg_data);
+
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_xfer(call_id, &dest, &msg_data);	
+    }
+
+    status = pjsua_call_xfer(call_id, &dest, &msg_data);
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_xfer(call_id, &dest, NULL);	
-    }
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5178,6 +3562,5 @@
  * py_pjsua_call_xfer_replaces
  */
-static PyObject *py_pjsua_call_xfer_replaces
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_xfer_replaces(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
@@ -5186,33 +3569,34 @@
     unsigned options;    
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple
-		(pArgs, "iiIO", &call_id, &dest_call_id, &options, &omdObj))
-    {
-        return NULL;
-    }
-	
-    if (omdObj != Py_None)
-    {
-        omd = (PyObj_pjsua_msg_data *)omdObj;    
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iiIO", &call_id, &dest_call_id, 
+			  &options, &omdObj))
+    {
+        return NULL;
+    }
+
+    pjsua_msg_data_init(&msg_data);
+
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
+        omd = (PyObj_pjsua_msg_data *)omdObj;
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_xfer_replaces
-			(call_id, dest_call_id, options, &msg_data);	
-        pj_pool_release(pool);
-    } else {
-        status = pjsua_call_xfer_replaces(call_id, dest_call_id,options, NULL);	
-    }
-    return Py_BuildValue("i",status);
+    }
+
+    status = pjsua_call_xfer_replaces(call_id, dest_call_id, options, 
+				      &msg_data);
+
+    if (pool)
+	pj_pool_release(pool);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5220,9 +3604,8 @@
  * py_pjsua_call_dial_dtmf
  */
-static PyObject *py_pjsua_call_dial_dtmf
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_dial_dtmf(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    PyObject * sd;
+    PyObject *pDigits;
     pj_str_t digits;
     int status;
@@ -5230,10 +3613,12 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iO", &call_id, &sd))
-    {
-        return NULL;
-    }	
-    digits.ptr = PyString_AsString(sd);
-    digits.slen = strlen(PyString_AsString(sd));
+    if (!PyArg_ParseTuple(pArgs, "iO", &call_id, &pDigits)) {
+        return NULL;
+    }
+
+    if (!PyString_Check(pDigits))
+	return Py_BuildValue("i", PJ_EINVAL);
+
+    digits = PyString_ToPJ(pDigits);
     status = pjsua_call_dial_dtmf(call_id, &digits);
     
@@ -5244,6 +3629,5 @@
  * py_pjsua_call_send_im
  */
-static PyObject *py_pjsua_call_send_im
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_send_im(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
@@ -5251,49 +3635,47 @@
     pj_str_t content;
     pj_str_t * mime_type, tmp_mime_type;
-    PyObject * sm;
-    PyObject * sc;
+    PyObject *pMimeType, *pContent, *omdObj;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
     int user_data;
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple
-		(pArgs, "iOOOi", &call_id, &sm, &sc, &omdObj, &user_data))
-    {
-        return NULL;
-    }
-    if (sm == Py_None)
-    {
-        mime_type = NULL;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOOOi", &call_id, &pMimeType, &pContent, 
+			  &omdObj, &user_data))
+    {
+        return NULL;
+    }
+
+    if (!PyString_Check(pContent))
+	return Py_BuildValue("i", PJ_EINVAL);
+
+    content = PyString_ToPJ(pContent);
+
+    if (PyString_Check(pMimeType)) {
+        mime_type = &tmp_mime_type;
+        tmp_mime_type = PyString_ToPJ(pMimeType);
     } else {
-        mime_type = &tmp_mime_type;
-        tmp_mime_type.ptr = PyString_AsString(sm);
-        tmp_mime_type.slen = strlen(PyString_AsString(sm));
-    }
-    content.ptr = PyString_AsString(sc);
-    content.slen = strlen(PyString_AsString(sc));
-    
-    if (omdObj != Py_None)
-    {
+	mime_type = NULL;   
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data * omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_send_im
-		(call_id, mime_type, &content, &msg_data, (void *)user_data);	
+    }
+    
+    status = pjsua_call_send_im(call_id, mime_type, &content, 
+				&msg_data, (void *)user_data);
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_send_im
-			(call_id, mime_type, &content, NULL, (void *)user_data);	
-    }
-    
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5301,6 +3683,6 @@
  * py_pjsua_call_send_typing_ind
  */
-static PyObject *py_pjsua_call_send_typing_ind
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_send_typing_ind(PyObject *pSelf, 
+					       PyObject *pArgs)
 {    
     int status;
@@ -5308,31 +3690,30 @@
     int is_typing;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &is_typing, &omdObj))
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &is_typing, &omdObj)) {
         return NULL;
     }
 	
-    if (omdObj != Py_None)
-    {
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_send_typing_ind(call_id, is_typing, &msg_data);	
+    }
+
+    status = pjsua_call_send_typing_ind(call_id, is_typing, &msg_data);	
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_send_typing_ind(call_id, is_typing, NULL);	
-    }
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5340,19 +3721,12 @@
  * py_pjsua_call_hangup_all
  */
-static PyObject *py_pjsua_call_hangup_all
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_hangup_all(PyObject *pSelf, PyObject *pArgs)
 {    	
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
     pjsua_call_hangup_all();
     
-    Py_INCREF(Py_None);
-    return Py_None;
+    return Py_BuildValue("");
 }
 
@@ -5360,13 +3734,12 @@
  * py_pjsua_call_dump
  */
-static PyObject *py_pjsua_call_dump
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_dump(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
     int with_media;
-    PyObject * sb;
-    PyObject * si;
-    char * buffer;
-    char * indent;
+    PyObject *ret;
+    PyObject *pIndent;
+    char *buffer;
+    char *indent;
     unsigned maxlen;    
     int status;
@@ -5374,15 +3747,22 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iiIO", &call_id, &with_media, &maxlen, &si))
+    if (!PyArg_ParseTuple(pArgs, "iiIO", &call_id, &with_media, 
+			  &maxlen, &pIndent))
     {
         return NULL;
     }	
-    buffer = (char *) malloc (maxlen * sizeof(char));
-    indent = PyString_AsString(si);
+
+    buffer = (char*) malloc(maxlen * sizeof(char));
+    indent = PyString_AsString(pIndent);
     
     status = pjsua_call_dump(call_id, with_media, buffer, maxlen, indent);
-    sb = PyString_FromStringAndSize(buffer, maxlen);
+    if (status != PJ_SUCCESS) {
+	free(buffer);
+	return PyString_FromString("");
+    }
+
+    ret = PyString_FromString(buffer);
     free(buffer);
-    return Py_BuildValue("O", sb);
+    return (PyObject*)ret;
 }
 
@@ -5394,56 +3774,15 @@
 static PyObject *py_pjsua_dump(PyObject *pSelf, PyObject *pArgs)
 {
-    unsigned old_decor;
-    char buf[1024];
     int detail;
 
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &detail))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &detail)) {
         return NULL;
     }	
 
-    PJ_LOG(3,(THIS_FILE, "Start dumping application states:"));
-
-    old_decor = pj_log_get_decor();
-    pj_log_set_decor(old_decor & (PJ_LOG_HAS_NEWLINE | PJ_LOG_HAS_CR));
-
-    if (detail)
-	pj_dump_config();
-
-    pjsip_endpt_dump(pjsua_get_pjsip_endpt(), detail);
-    pjmedia_endpt_dump(pjsua_get_pjmedia_endpt());
-    pjsip_tsx_layer_dump(detail);
-    pjsip_ua_dump(detail);
-
-
-    /* Dump all invite sessions: */
-    PJ_LOG(3,(THIS_FILE, "Dumping invite sessions:"));
-
-    if (pjsua_call_get_count() == 0) {
-
-	PJ_LOG(3,(THIS_FILE, "  - no sessions -"));
-
-    } else {
-	unsigned i, max;
-
-	max = pjsua_call_get_max_count();
-	for (i=0; i<max; ++i) {
-	    if (pjsua_call_is_active(i)) {
-		pjsua_call_dump(i, detail, buf, sizeof(buf), "  ");
-		PJ_LOG(3,(THIS_FILE, "%s", buf));
-	    }
-	}
-    }
-
-    /* Dump presence status */
-    pjsua_pres_dump(detail);
-
-    pj_log_set_decor(old_decor);
-    PJ_LOG(3,(THIS_FILE, "Dump complete"));
-
-    Py_INCREF(Py_None);
-    return Py_None;
+    pjsua_dump(detail);
+
+    return Py_BuildValue("");
 }
 
@@ -5456,15 +3795,15 @@
     int err;
     char err_msg[PJ_ERR_MSG_SIZE];
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &err))
-    {
-        return NULL;
-    }
-    
-    pj_strerror(err, err_msg, sizeof(err_msg));
-    
-    return PyString_FromString(err_msg);
+    pj_str_t ret;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &err)) {
+        return NULL;
+    }
+    
+    ret = pj_strerror(err, err_msg, sizeof(err_msg));
+    
+    return PyString_FromStringAndSize(err_msg, ret.slen);
 }
 
@@ -5475,5 +3814,5 @@
 static PyObject *py_pj_parse_simple_sip(PyObject *pSelf, PyObject *pArgs)
 {
-    const char *uri_param;
+    const char *arg_uri;
     pj_pool_t *pool;
     char tmp[PJSIP_MAX_URL_SIZE];
@@ -5484,10 +3823,9 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "s", &uri_param))
-    {
-        return NULL;
-    }
-    
-    strncpy(tmp, uri_param, sizeof(tmp));
+    if (!PyArg_ParseTuple(pArgs, "s", &arg_uri)) {
+        return NULL;
+    }
+    
+    strncpy(tmp, arg_uri, sizeof(tmp));
     tmp[sizeof(tmp)-1] = '\0';
 
@@ -5498,6 +3836,5 @@
 			!PJSIP_URI_SCHEME_IS_SIPS(uri))) {
 	pj_pool_release(pool);
-	Py_INCREF(Py_None);
-	return Py_None;
+	return Py_BuildValue("");
     }
     
@@ -5506,14 +3843,13 @@
 
     /* Scheme */
-    item = PyString_FromStringAndSize(pjsip_uri_get_scheme(uri)->ptr,
-				      pjsip_uri_get_scheme(uri)->slen);
+    item = PyString_FromPJ(pjsip_uri_get_scheme(uri));
     PyTuple_SetItem(ret, 0, item);
 
     /* Username */
-    item = PyString_FromStringAndSize(sip_uri->user.ptr, sip_uri->user.slen);
+    item = PyString_FromPJ(&sip_uri->user);
     PyTuple_SetItem(ret, 1, item);
 
     /* Host */
-    item = PyString_FromStringAndSize(sip_uri->host.ptr, sip_uri->host.slen);
+    item = PyString_FromPJ(&sip_uri->host);
     PyTuple_SetItem(ret, 2, item);
 
@@ -5530,6 +3866,5 @@
 	sip_uri->transport_param.slen = 0;
     }
-    item = PyString_FromStringAndSize(sip_uri->transport_param.ptr, 
-				      sip_uri->transport_param.slen);
+    item = PyString_FromPJ(&sip_uri->transport_param);
     PyTuple_SetItem(ret, 4, item);
 
@@ -5653,20 +3988,4 @@
     },
     {
-    	"pool_create", py_pjsua_pool_create, METH_VARARGS,
-    	pjsua_pool_create_doc
-    },
-    {
-    	"get_pjsip_endpt", py_pjsua_get_pjsip_endpt, METH_VARARGS,
-    	pjsua_get_pjsip_endpt_doc
-    },
-    {
-    	"get_pjmedia_endpt", py_pjsua_get_pjmedia_endpt, METH_VARARGS,
-    	pjsua_get_pjmedia_endpt_doc
-    },
-    {
-    	"get_pool_factory", py_pjsua_get_pool_factory, METH_VARARGS,
-    	pjsua_get_pool_factory_doc
-    },
-    {
     	"reconfigure_logging", py_pjsua_reconfigure_logging, METH_VARARGS,
     	pjsua_reconfigure_logging_doc
@@ -5747,4 +4066,12 @@
     },
     {
+        "acc_set_user_data", py_pjsua_acc_set_user_data, METH_VARARGS,
+        "Accociate user data with the account"
+    },
+    {
+        "acc_get_user_data", py_pjsua_acc_get_user_data, METH_VARARGS,
+        "Get account's user data"
+    },
+    {
         "acc_modify", py_pjsua_acc_modify, METH_VARARGS,
         pjsua_acc_modify_doc
@@ -5777,20 +4104,4 @@
         "acc_enum_info", py_pjsua_acc_enum_info, METH_VARARGS,
         pjsua_acc_enum_info_doc
-    },
-    {
-        "acc_find_for_outgoing", py_pjsua_acc_find_for_outgoing, METH_VARARGS,
-        pjsua_acc_find_for_outgoing_doc
-    },
-    {
-        "acc_find_for_incoming", py_pjsua_acc_find_for_incoming, METH_VARARGS,
-        pjsua_acc_find_for_incoming_doc
-    },
-    {
-        "acc_create_uac_contact", py_pjsua_acc_create_uac_contact, METH_VARARGS,
-        pjsua_acc_create_uac_contact_doc
-    },
-    {
-        "acc_create_uas_contact", py_pjsua_acc_create_uas_contact, METH_VARARGS,
-        pjsua_acc_create_uas_contact_doc
     },
     {
@@ -5815,4 +4126,8 @@
     },    
     {
+        "buddy_find", py_pjsua_buddy_find, METH_VARARGS,
+        "Find buddy with the specified URI"
+    },    
+    {
         "buddy_get_info", py_pjsua_buddy_get_info, METH_VARARGS,
         pjsua_buddy_get_info_doc
@@ -5825,4 +4140,12 @@
         "buddy_del", py_pjsua_buddy_del, METH_VARARGS,
         pjsua_buddy_del_doc
+    },
+    {
+        "buddy_set_user_data", py_pjsua_buddy_set_user_data, METH_VARARGS,
+        "Associate user data to the buddy object"
+    },
+    {
+        "buddy_get_user_data", py_pjsua_buddy_get_user_data, METH_VARARGS,
+        "Get buddy user data"
     },
     {
@@ -5859,8 +4182,4 @@
     },
     {
-        "conf_add_port", py_pjsua_conf_add_port, METH_VARARGS,
-        pjsua_conf_add_port_doc
-    },
-    {
         "conf_remove_port", py_pjsua_conf_remove_port, METH_VARARGS,
         pjsua_conf_remove_port_doc
@@ -5935,8 +4254,4 @@
         "set_null_snd_dev", py_pjsua_set_null_snd_dev, METH_VARARGS,
         pjsua_set_null_snd_dev_doc
-    },
-    {
-        "set_no_snd_dev", py_pjsua_set_no_snd_dev, METH_VARARGS,
-        pjsua_set_no_snd_dev_doc
     },
     {
@@ -6095,22 +4410,4 @@
     if (PyType_Ready(&PyTyp_pjsua_media_config) < 0)
         return;
-    PyTyp_pjsip_event.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pjsip_event) < 0)
-        return;
-    PyTyp_pjsip_rx_data.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pjsip_rx_data) < 0)
-        return;
-    PyTyp_pj_pool_t.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pj_pool_t) < 0)
-        return;
-    PyTyp_pjsip_endpoint.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pjsip_endpoint) < 0)
-        return;
-    PyTyp_pjmedia_endpt.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pjmedia_endpt) < 0)
-        return;
-    PyTyp_pj_pool_factory.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pj_pool_factory) < 0)
-        return;
     PyTyp_pjsip_cred_info.tp_new = PyType_GenericNew;
     if (PyType_Ready(&PyTyp_pjsip_cred_info) < 0)
@@ -6152,8 +4449,4 @@
 
     if (PyType_Ready(&PyTyp_pjsua_conf_port_info) < 0)
-        return;
-
-    PyTyp_pjmedia_port.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pjmedia_port) < 0)
         return;
 
@@ -6175,8 +4468,4 @@
     /* LIB CALL */
 
-    PyTyp_pj_time_val.tp_new = PyType_GenericNew;
-    if (PyType_Ready(&PyTyp_pj_time_val) < 0)
-        return;
-
     if (PyType_Ready(&PyTyp_pjsua_call_info) < 0)
         return;
@@ -6185,5 +4474,5 @@
 
     m = Py_InitModule3(
-        "_pjsua", py_pjsua_methods,"PJSUA-lib module for python"
+        "_pjsua", py_pjsua_methods, "PJSUA-lib module for python"
     );
 
@@ -6202,24 +4491,4 @@
     Py_INCREF(&PyTyp_pjsua_msg_data);
     PyModule_AddObject(m, "Msg_Data", (PyObject *)&PyTyp_pjsua_msg_data);
-
-    Py_INCREF(&PyTyp_pjsip_event);
-    PyModule_AddObject(m, "Pjsip_Event", (PyObject *)&PyTyp_pjsip_event);
-
-    Py_INCREF(&PyTyp_pjsip_rx_data);
-    PyModule_AddObject(m, "Pjsip_Rx_Data", (PyObject *)&PyTyp_pjsip_rx_data);
-
-    Py_INCREF(&PyTyp_pj_pool_t);
-    PyModule_AddObject(m, "Pj_Pool", (PyObject *)&PyTyp_pj_pool_t);
-
-    Py_INCREF(&PyTyp_pjsip_endpoint);
-    PyModule_AddObject(m, "Pjsip_Endpoint", (PyObject *)&PyTyp_pjsip_endpoint);
-
-    Py_INCREF(&PyTyp_pjmedia_endpt);
-    PyModule_AddObject(m, "Pjmedia_Endpt", (PyObject *)&PyTyp_pjmedia_endpt);
-
-    Py_INCREF(&PyTyp_pj_pool_factory);
-    PyModule_AddObject(
-        m, "Pj_Pool_Factory", (PyObject *)&PyTyp_pj_pool_factory
-    );
 
     Py_INCREF(&PyTyp_pjsip_cred_info);
@@ -6265,6 +4534,4 @@
     Py_INCREF(&PyTyp_pjsua_conf_port_info);
     PyModule_AddObject(m, "Conf_Port_Info", (PyObject *)&PyTyp_pjsua_conf_port_info);
-    Py_INCREF(&PyTyp_pjmedia_port);
-    PyModule_AddObject(m, "PJMedia_Port", (PyObject *)&PyTyp_pjmedia_port);
     Py_INCREF(&PyTyp_pjmedia_snd_dev_info);
     PyModule_AddObject(m, "PJMedia_Snd_Dev_Info", 
@@ -6284,7 +4551,4 @@
     /* LIB CALL */
 
-    Py_INCREF(&PyTyp_pj_time_val);
-    PyModule_AddObject(m, "PJ_Time_Val", (PyObject *)&PyTyp_pj_time_val);
-
     Py_INCREF(&PyTyp_pjsua_call_info);
     PyModule_AddObject(m, "Call_Info", (PyObject *)&PyTyp_pjsua_call_info);
@@ -6296,54 +4560,5 @@
      * Add various constants.
      */
-
-    /* Call states */
-    ADD_CONSTANT(m, PJSIP_INV_STATE_NULL);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_CALLING);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_INCOMING);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_EARLY);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_CONNECTING);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_CONFIRMED);
-    ADD_CONSTANT(m, PJSIP_INV_STATE_DISCONNECTED);
-
-    /* Call media status (enum pjsua_call_media_status) */
-    ADD_CONSTANT(m, PJSUA_CALL_MEDIA_NONE);
-    ADD_CONSTANT(m, PJSUA_CALL_MEDIA_ACTIVE);
-    ADD_CONSTANT(m, PJSUA_CALL_MEDIA_LOCAL_HOLD);
-    ADD_CONSTANT(m, PJSUA_CALL_MEDIA_REMOTE_HOLD);
-
-    /* Buddy status */
-    ADD_CONSTANT(m, PJSUA_BUDDY_STATUS_UNKNOWN);
-    ADD_CONSTANT(m, PJSUA_BUDDY_STATUS_ONLINE);
-    ADD_CONSTANT(m, PJSUA_BUDDY_STATUS_OFFLINE);
-
-    /* PJSIP transport types (enum pjsip_transport_type_e) */
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_UNSPECIFIED);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_UDP);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_TCP);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_TLS);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_SCTP);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_LOOP);
-    ADD_CONSTANT(m, PJSIP_TRANSPORT_LOOP_DGRAM);
-
-
-    /* Invalid IDs */
-    ADD_CONSTANT(m, PJSUA_INVALID_ID);
-
-
-    /* Various compile time constants */
-    ADD_CONSTANT(m, PJSUA_ACC_MAX_PROXIES);
-    ADD_CONSTANT(m, PJSUA_MAX_ACC);
-    ADD_CONSTANT(m, PJSUA_REG_INTERVAL);
-    ADD_CONSTANT(m, PJSUA_PUBLISH_EXPIRATION);
-    ADD_CONSTANT(m, PJSUA_DEFAULT_ACC_PRIORITY);
-    ADD_CONSTANT(m, PJSUA_MAX_BUDDIES);
-    ADD_CONSTANT(m, PJSUA_MAX_CONF_PORTS);
-    ADD_CONSTANT(m, PJSUA_DEFAULT_CLOCK_RATE);
-    ADD_CONSTANT(m, PJSUA_DEFAULT_CODEC_QUALITY);
-    ADD_CONSTANT(m, PJSUA_DEFAULT_ILBC_MODE);
-    ADD_CONSTANT(m, PJSUA_DEFAULT_EC_TAIL_LEN);
-    ADD_CONSTANT(m, PJSUA_MAX_CALLS);
-    ADD_CONSTANT(m, PJSUA_XFER_NO_REQUIRE_REPLACES);
-
+    /* Skip it.. */
 
 #undef ADD_CONSTANT
